% BU.PRO: Abstractions about behavioural units.
% Author: Frans A.Meijs, 1992

diNet(DN) :- behaviouralUnit(DN).


state__e_entity(S,BU) :-
   state__e_bu(S,BU).


state__e_bu(ST,BU) :-
   nonvar(ST),
   state__isExplicitlyInstanceOf_stateVariable(ST,SV),
   stateVariable__isPrivateElementOf_bu(SV,BU).
state__e_bu(ST,BU) :-
   var(ST),nonvar(BU),
   stateVariable__isPrivateElementOf_bu(SV,BU),
   state__isExplicitlyInstanceOf_stateVariable(ST,SV).


concept__isExplicitlyElementOf_set(M,BU) :-
   mapping__e_bu(M,BU).


eachInstanceOfClass__isExplicitlyElementOf_set(IC,S) :-
   stateVariable__e_bu(IC,S).
eachInstanceOfClass__isExplicitlyElementOf_set(IC,S) :-
   mappingClass__e_bu(IC,S).


stateVariable__e_bu(SV,BU) :-
   stateVariable__isPrivateElementOf_bu(SV,BU).       % Note 1.


stateVariable__isPrivateElementOf_bu(SV,BU) :-
   nonvar(SV),
   stateVariable__e_vectorVariableElement(SV,VE),
   vectorVariableElement__e_vectorVariable(VE,SVCTR),
   stateVectorVariable__e_bu(SVCTR,BU).
stateVariable__isPrivateElementOf_bu(SV,BU) :-
   var(SV),nonvar(BU),
   stateVectorVariable__e_bu(SVCTR,BU),
   vectorVariableElement__e_vectorVariable(VE,SVCTR),
   stateVariable__e_vectorVariableElement(SV,VE).
               % This allows specs including vectors as well as excluding them.


entity__e_entity(E1,E2) :-
   stateVector__e_bu(E1,E2).
%entity__e_entity(E1,E2) :-
%   interfaceVector__e_bu(E1,E2).       % For documentation only.
      

%:- consult('bu.prc').

% Notes:

% 1. The other stateVariable__e_bu/2 defs are in SU.PRO
