% CLASS.PRC

contradiction(['Contrad. class CLASS1: Concept', X,
   'seems to be a class but is not declared as such']) :-
   o_verifyingLogMsg('CLASS1'),
   class__isExplicitlySubclassOf_class(_, X),
   ~( class(X) ).
      % This is the first part of the Referential Integrity Constraint
      % from data base theory.


contradiction(['Contrad. class CLASS2: Concept', X,
   'seems to be a class but is not declared as such']) :-
   o_verifyingLogMsg('CLASS2'),
   class__isExplicitlySubclassOf_class(X, _),
   ~( class(X) ).
      % This is the second part of the Referential Integrity Constraint
      % from relational data base theory.
      % Classes are required to be specified explicitly. The 
      % alternative, the introduction of the specification  
      %    "class(C) :- class__isExplicitlyElementOf_class(C,_)." 
      % may cause duplicate solutions, and 
      % hence may increase verification time considerably.


contradiction(
   ['Contrad. class CLASS4', C1,
   'and', C2,
   'are both root in the classification tree']) :-
   o_verifyingLogMsg('CLASS4'),
   class(C1),
   ~( class__isExplicitlySubclassOf_class(C1, _) ),
   class(C2),
   id__lt_id(C1, C2),
   ~( class__isExplicitlySubclassOf_class(C2, _) ).

 

