% CLASS.PRO: Abstractions about classes without explicit 
% identification of their instances.
% Author: Frans Meijs, 1990

concept(S) :- class(S).

concept__isExplicitlyAssociatedWith_concept(C1,C2) :-
   class__isSubclassOf_class(C1,C2).


class__isSubclassOf_class(C,C2) :- 
   class__isExplicitlySubclassOf_class(C,C2).
class__isSubclassOf_class(C1,C2) :-
   class__isExplicitlySubclassOf_class(C1,C3),
   C1 \= C3,            % Avoid infinite loop in case of erratic spec.
   class__isSubclassOf_class(C3,C2). 
               % It is assumed that there are no cycles (See CLASS.PRC).


association(A) :-
   nonvar(A),
   A = [C1|[C2]],
   class__isElementarySubclassOf_class(C1,C2).
association(A) :-
   var(A),
   class__isElementarySubclassOf_class(C1,C2),
   A = [C1,C2].
            % class__isElementarySubclassOf_class/2 is an 
            % auxiliary predicate.
            % For that reason it is not made subclass of 
            % concept__isExplicitlyAssociatedWith_concept/2.


class__isElementarySubclassOf_class(C1,C2) :-
   class__isSubclassOf_class(C1,C2),
   ~( class__isExplicitlySubclassOf_class(_,C1) ).



%:- consult('class.prc'). 
%:- consult('class.prp'). 


