% CONCEPT.PRO: The theory with the highest level of abstraction.
% Author: Frans Meijs, 1990


concept(C) :- contradiction(C).        % For verification purposes.
concept(C) :- association(C).


association(A) :-
   nonvar(A),
   A = [C1|[C2]],
   concept__isAssociatedWith_concept(C1,C2).
association(A) :-
   var(A),
   concept__isAssociatedWith_concept(C1,C2),
   A = [C1,C2].


concept__isAssociatedWith_concept(C1,C2) :-
   concept__isExplicitlyAssociatedWith_concept(C1,C2).
         % Association is directed from subject noun to object noun, so
         %    concept__isExplicitlyAssociatedWith_concept(C2,C1) :-
         %                  concept__isAssociatedWith_concept(C1,C2).
         % is NOT true.
concept__isAssociatedWith_concept(C1,C2) :-
   concept__isExplicitlyAssociatedWith_concept(C1,C3),
   concept__isAssociatedWith_concept(C3,C2).
         % Because it is the most general closure, this clause is unrestricted w.r.t.
         % binding of C1 and C2.


%:- consult('concept.prc').
