% CONN_NET.PRO: Abstractions about connected networks.


network(CN) :- connNet(CN).


setOfConnections__e_implicitConnNet__in_network(CS, ICN, N) :-
   nonvar(CS), nonvar(N),
   list__has_length(CS, L),
   L > 1,
   ~(
     setOfConnections__connectsTo_connection__in_network(CS, _, N)
    ),
   ICN = CS,
   !.                                       % Solution is sufficient.
setOfConnections__e_implicitConnNet__in_network(CS, ICN, N) :-
   nonvar(CS), nonvar(N),
   setOfConnections__connectsTo_connection__in_network(CS, C, N),
   CS2 = [C| CS],
   setOfConnections__e_implicitConnNet__in_network(CS2, ICN, N).


setOfConnections__connectsTo_connection__in_network(CS, C, N) :-
   nonvar(CS), nonvar(N),
   term__isMemberOf_list(C1, CS),
   connection__e_network(C1, N),        % Limitation of search space 
                                        % for ver. speed. (Compositional
                                        % semantics)
   connection__connects_node(C1, ND),
   connection__connects_node(C, ND),
   connection__e_network(C, N),
   C \== C1,
   ~( term__isMemberOf_list__v2(C, CS) ),
   !.                                       % Solution is sufficient.


%:- consult('conn_net.prc').

