% EMC.PRC: The constraints.

contradiction(['Contrad. class EMC1',X,
   'maps from more than two state variables, one being',Y]) :-
   entityMappingClass__mapsFrom_stateVariable(X,Y),
   o_verifyingLogMsg('EMC1'),
   propositionSet__has_cardinalNumber(
      entityMappingClass__mapsFrom_stateVariable(X,_),
      N),
   N > 2.


contradiction(['Contrad. class EMC2',X,
   'maps to more than one state variable, one being',Y]) :-
   entityMappingClass__mapsTo_stateVariable(X,Y),
   o_verifyingLogMsg('EMC2'),
   propositionSet__has_cardinalNumber(
      entityMappingClass__mapsTo_stateVariable(X,_),
      N),
   N > 1.


contradiction(['Contrad. class EMC3',EMC,
   'maps from state variable',ESV,
   'associated to sort',S,
   'which is no subset of the sort of entities']) :-
   o_verifyingLogMsg('EMC3'),
   entityMappingClass__mapsFrom_stateVariable(EMC,ESV),
   stateVariable__isAssociatedWith_sort(ESV,S),
   S \= ['SortOf','entities'],
   ~( sort__e_sort(S,['SortOf','entities']) ).


contradiction(['Contrad. class EMC4',EMC,
   'maps to state variable',ESV,
   'associated to sort',S,
   'which is no subset of the sort of entities']) :-
   o_verifyingLogMsg('EMC4'),
   entityMappingClass__mapsTo_stateVariable(EMC,ESV),
   stateVariable__isAssociatedWith_sort(ESV,S),
   S \= ['SortOf','entities'],
   ~( sort__e_sort(S,['SortOf','entities']) ).

