% EMC.PRO: Abstractions about entity mapping classes.


state__i_stateVariable(E,SV) :-
   entity__i_stateVariable(E,SV).

eachInstanceOfMc__mapsFromAnInstanceOf_sv(EMC,SV) :-
   entityMappingClass__mapsFrom_stateVariable(EMC,SV).

eachInstanceOfMc__mapsToAnInstanceOf_sv(EMC,SV) :-
   entityMappingClass__mapsTo_stateVariable(EMC,SV).


entity__i_stateVariable(S,SV) :-
   entityMappingClass__mapsTo_stateVariable(EMC,SV),
   class__isExplicitlySubclassOf_class(EMC,'intersection'),
   entityMappingClass__mapsFrom_stateVariable(EMC,SV1),
   entityMappingClass__mapsFrom_stateVariable(EMC,SV2),
   id__lt_id(SV1,SV2),
   entity__isExplicitlyInstanceOf_stateVariable(S1,SV1),
   entity__isExplicitlyInstanceOf_stateVariable(S2,SV2),
   ~( entity__hasAnElementWhichIsNotSharedBy_entity(S,S1) ),
   ~( entity__hasAnElementWhichIsNotSharedBy_entity(S,S2) ),
   state__isNextInstanceOf_stateVariable(S,SV).
entity__i_stateVariable(S,SV) :-
   entityMappingClass__mapsTo_stateVariable(EMC,SV),
   class__isExplicitlySubclassOf_class(EMC,'union'),
   entityMappingClass__mapsFrom_stateVariable(EMC,SV1),
   entityMappingClass__mapsFrom_stateVariable(EMC,SV2),
   id__lt_id(SV1,SV2),
   entity__isExplicitlyInstanceOf_stateVariable(S1,SV1),
   entity__isExplicitlyInstanceOf_stateVariable(S2,SV2),
   ~( entity__hasAnElementWhichIsNotSharedBy_entity(S1,S) ),
   ~( entity__hasAnElementWhichIsNotSharedBy_entity(S2,S) ),
   state__isNextInstanceOf_stateVariable(S,SV).
entity__i_stateVariable(S,SV) :-
   entityMappingClass__mapsTo_stateVariable(EMC,SV),
   class__isExplicitlySubclassOf_class(EMC,'subtraction'),
   entityMappingClass__subtractsFrom_stateVariable(EMC,SV1),
   entityMappingClass__subtracts_stateVariable(EMC,SV2),
   id__lt_id(SV1,SV2),
   entity__isExplicitlyInstanceOf_stateVariable(S1,SV1),
   entity__isExplicitlyInstanceOf_stateVariable(S2,SV2),
   ~( entity__hasAnElementWhichIsNotSharedBy_entity(S,S1) ),
   ~( entity__hasAnElementWhichIsSharedBy_entity(S,S2) ),
   state__isNextInstanceOf_stateVariable(S,SV).


entityMappingClass__mapsFrom_stateVariable(EMC,SV) :-
   entityMappingClass__subtractsFrom_stateVariable(EMC,SV).
entityMappingClass__mapsFrom_stateVariable(EMC,SV) :-
   entityMappingClass__subtracts_stateVariable(EMC,SV).


entity__hasAnElementWhichIsNotSharedBy_entity(S1,S2) :-
   state__e_entity(ST,S1),
   ~( state__e_entity(ST,S2) ).

entity__hasAnElementWhichIsSharedBy_entity(S,S2) :-
   state__e_entity(ST,S),
   state__e_entity(ST,S2).


%:- consult('emc.prc').
%:- consult('emc.prp').
