% HIERARCH.PRO: Abstractions about hierarchies.


diNet(H) :- hierarchy(H).


setOfConnections__e_implicitHierarchy__in_diNet(CS,IHR,N) :-
   nonvar(CS),nonvar(N),
   list__has_length(CS,L),
   L > 1,
   ~(
     setOfConnections__connectsTo_connection__in_diNet(CS,_,N)
    ),
   IHR = CS,
   !.                                       % Solution is sufficient.
setOfConnections__e_implicitHierarchy__in_diNet(CS,IHR,N) :-
   nonvar(CS),nonvar(N),
   setOfConnections__connectsTo_connection__in_diNet(CS,C,N),
   ~( connection__makesCycleInto_diNet(C,CS) ),
   CS2 = [C|CS],
   setOfConnections__e_implicitHierarchy__in_diNet(CS2,IHR,N).
setOfConnections__e_implicitHierarchy__in_diNet(CS,IHR,N) :-
   nonvar(CS),nonvar(N),
   setOfConnections__connectsTo_connection__in_diNet(CS,C,N),
   connection__makesCycleInto_diNet(C,CS),
   IHR = CS.
                   % The implicit hierarchy is not needed to be complete.


setOfConnections__connectsTo_connection__in_diNet(CS,C,N) :-
   nonvar(CS),nonvar(N),
   term__isMemberOf_list(C1,CS),
   connection__e_network(C1,N),       % Limitation of search space 
                                        % for ver. speed. (Compositional
                                        % semantics)
   connection__connectsTo_node(C1,ND),
   connection__connectsFrom_node(C,ND),
   connection__e_network(C,N),
   ~( term__isMemberOf_list__v2(C,CS) ).


connection__makesCycleInto_diNet(C,CS) :-
   nonvar(C),nonvar(CS),
   connection__connectsTo_node(C,ND2),
   connection__connectsFrom_node(C2,ND2),
   term__isMemberOf_list__v2(C2,CS),
   C2_L = [C2],
   path__connectedTo_connection__isPath(C2_L,C,_).
 

path__connectedTo_connection__isPath(P,C,P2) :-
   nonvar(P),nonvar(C),
   P2 = [C|P],
   P = [C1|_],
   connection__connectsTo_node(C1,ND),
   connection__connectsFrom_node(C,ND),
   !.                                        % Solution is sufficient.
path__connectedTo_connection__isPath(P1,C2,P2) :-
   nonvar(P1),nonvar(C2),
   P1 = [C1|_],
   connection__connectsTo_node(C1,ND),
   connection__connectsFrom_node(C3,ND),
   ~( term__isMemberOf_list__v2(C3,P1) ),
   path__connectedTo_connection__isPath([C3|P1],C2,P2).
   

