% MAPPINGC.PRC: The constraints.
% (c) Author: Frans A. Meijs, 1992.

contradiction(['Contrad. class MAPPINGC1: state variable',SV,
      'has more than one instantaneous state']) :-
   o_verifyingLogMsg('MAPPINGC1'),
   class__isSubclassOf_class(SV,'StateVariable'),
   propositionSet__has_cardinalNumber(
        state__isExplicitlyInstanceOf_stateVariable(_,SV),
        N),
   N > 1.  
 
contradiction(['Contrad. class MAPPINGC2: sort',S,
      'is associated with state variable',SV,
      'but is not declared as such']) :-
   o_verifyingLogMsg('MAPPINGC2'),
   stateVariable__isExplicitlyAssociatedWith_sort(SV,S),
   ~( sort(S) ).  
 
contradiction(['Contrad. class MAPPINGC11: Instantaneous state',S,
      'of state variable',SV,
      'is not element of the sort',DS]) :- 
   o_verifyingLogMsg('MAPPINGC11'),
   state__isExplicitlyInstanceOf_stateVariable(S,SV),
   stateVariable__isAssociatedWith_sort(SV,DS),
   ~( concept__e_set(S,DS) ).

contradiction(['Contrad. class MAPPINGC21: State variable',SV,
      'in mapping class',MC,
      'is not associated with any sort']) :- 
   o_verifyingLogMsg('MAPPINGC21'),
   eachInstanceOfMc__mapsFromAnInstanceOf_sv(MC,SV),
   ~( class__isExplicitlySubclassOf_class(_,SV) ),
   ~( stateVariable__isExplicitlyAssociatedWith_sort(SV,_) ).

contradiction(['Contrad. class MAPPINGC22: State variable',SV,
      'in mapping class',MC,
      'is not associated with any sort']) :- 
   o_verifyingLogMsg('MAPPINGC22'),
   eachInstanceOfMc__mapsToAnInstanceOf_sv(MC,SV),
   ~( stateVariable__isExplicitlyAssociatedWith_sort(SV,_) ).

contradiction(['Contrad. class MAPPINGC41: Mapping class',MC,
      'maps from superclass',SV]) :- 
   o_verifyingLogMsg('MAPPINGC41'),
   eachInstanceOfMc__mapsFromAnInstanceOf_sv(MC,SV),
   exists( class__isExplicitlySubclassOf_class(_,SV) ).

contradiction(['Contrad. class MAPPINGC42: Mapping class',MC,
      'maps to superclass',SV]) :- 
   o_verifyingLogMsg('MAPPINGC42'),
   eachInstanceOfMc__mapsToAnInstanceOf_sv(MC,SV),
   exists( class__isExplicitlySubclassOf_class(_,SV) ).

