% MAPPINGC.PRO: Abstractions about mapping classes.
% Author: Frans Meijs, 1992


concept__isExplicitlyAssociatedWith_concept(C,S) :-
   class__isAssociatedWith_set(C,S).
concept__isExplicitlyAssociatedWith_concept(S,C) :-
   state__isExplicitlyAssociatedWith_class(S,C).
concept__isExplicitlyAssociatedWith_concept(M,MC) :-
   mapping__isExplicitlyInstanceOf_mappingClass(M,MC).
concept__isExplicitlyAssociatedWith_concept(C1,C2) :-
   state__isNextInstanceOf_stateVariable(C1,C2).
concept__isExplicitlyAssociatedWith_concept(C1,C2) :-
   eachInstanceOfMc__mapsFromAnInstanceOf_sv(C1,C2).
concept__isExplicitlyAssociatedWith_concept(C1,C2) :-
   eachInstanceOfMc__mapsToAnInstanceOf_sv(C1,C2).


class__isAssociatedWith_set(SV,DS) :-
   stateVariable__isAssociatedWith_sort(SV,DS).


stateVariable__isAssociatedWith_sort(SV,DS) :-
   stateVariable__isExplicitlyAssociatedWith_sort(SV,DS).
stateVariable__isAssociatedWith_sort(SV,DS) :-
   nonvar(SV),
   stateVariable__isExplicitlyAssociatedWith_sort(SV,DS2),
   sort__e_sort(DS,DS2),
   exists( sort(DS) ).
stateVariable__isAssociatedWith_sort(SV,DS) :-
   var(SV),nonvar(DS),
   exists( sort(DS) ),
   sort__e_sort(DS,DS2),
   stateVariable__isExplicitlyAssociatedWith_sort(SV,DS2).


state__isExplicitlyAssociatedWith_class(S,SV) :-
   state__i_stateVariable(S,SV).


state__isNextInstanceOf_stateVariable(IS,SV) :-
   nonvar(IS), nonvar(SV),
   retract( state__isExplicitlyInstanceOf_stateVariable(_,SV) ),
   assert( state__isExplicitlyInstanceOf_stateVariable(IS,SV) ).    
                                                % Notes 1 and 2.
                                    

% Notes:

% 1. The relation between "_i_" and "_isExplicitlyInstanceOf_"
%    is made by specific mapping classes.
% 2. Update of the specification of the instantaneous state.
%    This represents the operational semantics of mapping classes.
% 3. Associations with diNets have to be made in more specific 
%    theories, dependent on the type of information to be verified.

%:- consult('mappingc.prc').
%:- consult('mappingc.prp').


