% MSGV.PRO: Abstractions about message- and signalling variables.
% Author: Frans A. Meijs, 1996.

psvs(MSGV) :- msgv(MSGV).

stateVariable__isExplicitlyAssociatedWith_sort(SEV,S) :-
   class__isSubclassOf_class(SEV, 'SignallingEventVariable'),
   S = ['SortOf','booleanStates'].

class__isExplicitlySubclassOf_class(SEV,'MsgSignallingEventVariable') :-
   exists( sev__e_msgv(SEV,_) ).

class__isExplicitlySubclassOf_class(DV,'DataVariable') :-
   exists( dataVariable__e_msgv(DV,_) ).

stateVariable__isExplicitlyShareableElementOf_su(DV,MSGV) :-
   dataVariable__e_msgv(DV,MSGV).
stateVariable__isExplicitlyShareableElementOf_su(SEV,MSGV) :-
   sev__e_msgv(SEV,MSGV).

psvs__isExplicitlyPrivateElementOf_su(MSGV,SU) :-
   msgv__isExplicitlyPrivateElementOf_su(MSGV,SU).

psvs__isInputElementOf_su(MSGV,SU) :-
   msgv__isInputElementOf_su(MSGV,SU).

psvs__isOutputElementOf_su(MSGV,SU) :-
   msgv__isOutputElementOf_su(MSGV,SU).


sev__e_msgv(SEV,MSGV) :-
   nonvar(SEV),
   sevId__eq_msgvId(SEV,MSGV),
   msgv(MSGV).
sev__e_msgv(SEV,MSGV) :-
   var(SEV),
   msgv(MSGV),
   sevId__eq_msgvId(SEV,MSGV).


   % Shorthand notation for MSGV-s.


msgv__isInputElementOf_su(MSGV,SU) :-
   msgv__isElementaryElementOf_msgv(MSGV,MSGV2),
   msgv__isInputElementOf_su(MSGV2,SU).
   

msgv__isOutputElementOf_su(MSGV,SU) :-
   msgv__isElementaryElementOf_msgv(MSGV,MSGV2),
   msgv__isOutputElementOf_su(MSGV2,SU).
   

msgv__isElementaryElementOf_msgv(MSGV1,MSGV2) :-
   msgv__e_msgv(MSGV1,MSGV2),
   ~( msgv__isExplicitlyElementOf_msgv(_,MSGV1) ).


structuralUnit__isExplicitlyPrivateElementOf_su(SU1,SU2) :-
   msgv__isExplicitlyElementOf_msgv(SU1,SU2).   % For constraint SU31.


msgv__e_msgv(C1,C2) :-
   msgv__isExplicitlyElementOf_msgv(C1,C2).
msgv__e_msgv(C1,C2) :-
   msgv__isExplicitlyElementOf_msgv(C1,C3),
   msgv__e_msgv(C3,C2).


   
%:- consult('msgv.prp').
%:- consult('msgv.prq').
%:- consult('msgv.prc').
