% NMC.PRC

contradiction(['Contrad. class NMC1', MC,
   'maps from more than two variables;']) :-
   o_verifyingLogMsg('NMC1'),
   numericMc__mapsFrom_numericSv(MC, _),
   propositionSet__has_cardinalNumber(
     numericMc__mapsFrom_numericSv(MC, _),
     N),
   N > 2.

contradiction(['Contrad. class NMC2', MC,
   'maps to more than one variable;']) :-
   o_verifyingLogMsg('NMC2'),
   numericMc__mapsTo_numericSv(MC,_),
   propositionSet__has_cardinalNumber(
     numericMc__mapsTo_numericSv(MC, _),
     N),
   N > 1.

contradiction(['Contrad. class NMC11', NMC,
   'maps from non-numeric variable', NSV]) :-
   o_verifyingLogMsg('NMC11'),
   numericMc__mapsFrom_numericSv(NMC, NSV),
   ~( stateVariable__isAssociatedWith_sort(
                                          NSV, ['SortOf', 'numbers']) ).

contradiction(['Contrad. class NMC12', NMC,
   'maps to non-numeric variable', NSV]) :-
   o_verifyingLogMsg('NMC12'),
   numericMc__mapsTo_numericSv(NMC, NSV),
   ~( stateVariable__isAssociatedWith_sort(
                                          NSV, ['SortOf', 'numbers']) ).


contradiction(['Contrad. class NMC21', NSV,
   'has a non-alphanumeric unit of measure', UM]) :-
   o_verifyingLogMsg('NMC21'),
   unitOfMeasure__isAssociatedWith_numericSv(UM, NSV),
   ~( chars(UM) ).


contradiction(['Contrad. class NMC22', NMC,
   'maps to', NSV,
   'which has a pre-specified unit of measure', UM]) :-
   o_verifyingLogMsg('NMC22'),
   unitOfMeasure__isAssociatedWith_numericSv(UM, NSV),
   numericMc__mapsTo_numericSv(NMC, NSV).
   


