% NMC.PRO: Abstractions about numeric mapping classes.
% Author: Frans Meijs, 1992


state__i_stateVariable(N,NSV) :-
   number__i_numericSv(N,NSV).


concept__isExplicitlyAssociatedWith_concept(UM,NSV) :-
   unitOfMeasure__isAssociatedWith_numericSv(UM,NSV).


elemStateMappingClass__mapsFrom_stateVariable(NMC,NSV) :-
   numericMc__mapsFrom_numericSv(NMC,NSV).


elemStateMappingClass__mapsTo_stateVariable(NMC,NSV) :-
   numericMc__mapsTo_numericSv(NMC,NSV).


number__i_numericSv(N,NSV) :-
   nonvar(NSV),
   numericMc__mapsTo_numericSv(NMC,NSV),
   numericMc__mapsFrom_numericSv(NMC,NSV1),
   numericMc__mapsFrom_numericSv(NMC,NSV2),
   id__lt_id(NSV1,NSV2),
   stateVariable__isAssociatedWith_sort(NSV1,['SortOf','integerNumbers']),
   stateVariable__isAssociatedWith_sort(NSV2,['SortOf','integerNumbers']),
   state__isExplicitlyInstanceOf_stateVariable(N1,NSV1),
   state__isExplicitlyInstanceOf_stateVariable(N2,NSV2),
   class__isSubclassOf_class(NMC,'+'),
   int__plus_int__is_int(N1,N2,N),        % Predefined arithmetic of Prolog.
   state__isNextInstanceOf_stateVariable(N,NSV).
number__i_numericSv(N,NSV) :-
   nonvar(NSV),
   numericMc__mapsTo_numericSv(NMC,NSV),
   numericMc__mapsFrom_numericSv(NMC,NSV1),
   numericMc__mapsFrom_numericSv(NMC,NSV2),
   id__lt_id(NSV1,NSV2),
   stateVariable__isAssociatedWith_sort(NSV1,['SortOf','realNumbers']),
   stateVariable__isAssociatedWith_sort(NSV2,['SortOf','realNumbers']),
   state__isExplicitlyInstanceOf_stateVariable(N1,NSV1),
   state__isExplicitlyInstanceOf_stateVariable(N2,NSV2),
   class__isSubclassOf_class(NMC,'+'),
   real__plus_real__is_real(N1,N2,N),     % Predefined arithmetic of Prolog.
   state__isNextInstanceOf_stateVariable(N,NSV).
number__i_numericSv(N,NSV) :-
   nonvar(NSV),
   numericMc__mapsTo_numericSv(NMC,NSV),
   numericMc__mapsFrom_numericSv(NMC,NSV1),
   numericMc__mapsFrom_numericSv(NMC,NSV2),
   id__lt_id(NSV1,NSV2),
   stateVariable__isAssociatedWith_sort(NSV1,['SortOf','integerNumbers']),
   stateVariable__isAssociatedWith_sort(NSV2,['SortOf','integerNumbers']),
   state__isExplicitlyInstanceOf_stateVariable(N1,NSV1),
   state__isExplicitlyInstanceOf_stateVariable(N2,NSV2),
   class__isSubclassOf_class(NMC,'*'),
   int__times_int__is_int(N1,N2,N),        % Predefined arithmetic of Prolog.
   state__isNextInstanceOf_stateVariable(N,NSV).
number__i_numericSv(N,NSV) :-
   nonvar(NSV),
   numericMc__mapsTo_numericSv(NMC,NSV),
   numericMc__mapsFrom_numericSv(NMC,NSV1),
   numericMc__mapsFrom_numericSv(NMC,NSV2),
   id__lt_id(NSV1,NSV2),
   stateVariable__isAssociatedWith_sort(NSV1,['SortOf','realNumbers']),
   stateVariable__isAssociatedWith_sort(NSV2,['SortOf','realNumbers']),
   state__isExplicitlyInstanceOf_stateVariable(N1,NSV1),
   state__isExplicitlyInstanceOf_stateVariable(N2,NSV2),
   class__isSubclassOf_class(NMC,'*'),
   real__times_real__is_real(N1,N2,N),
                                    % Predefined arithmetic of Prolog.
   state__isNextInstanceOf_stateVariable(N,NSV).
number__i_numericSv(N,NSV) :-
   nonvar(NSV),
   numericMc__mapsTo_numericSv(NMC,NSV),
   subtractionClass__subtracts_numericSv(NMC,NSV1),
   subtractionClass__subtractsBy_numericSv(NMC,NSV2),
   stateVariable__isAssociatedWith_sort(NSV1,['SortOf','integerNumbers']),
   stateVariable__isAssociatedWith_sort(NSV2,['SortOf','integerNumbers']),
   state__isExplicitlyInstanceOf_stateVariable(N1,NSV1),
   state__isExplicitlyInstanceOf_stateVariable(N2,NSV2),
   class__isSubclassOf_class(NMC,'-'),
   int__minus_int__is_int(N1,N2,N),        % Predefined arithmetic of Prolog.
   state__isNextInstanceOf_stateVariable(N,NSV).
number__i_numericSv(N,NSV) :-
   nonvar(NSV),
   numericMc__mapsTo_numericSv(NMC,NSV),
   subtractionClass__subtracts_numericSv(NMC,NSV1),
   subtractionClass__subtractsBy_numericSv(NMC,NSV2),
   stateVariable__isAssociatedWith_sort(NSV1,['SortOf','realNumbers']),
   stateVariable__isAssociatedWith_sort(NSV2,['SortOf','realNumbers']),
   state__isExplicitlyInstanceOf_stateVariable(N1,NSV1),
   state__isExplicitlyInstanceOf_stateVariable(N2,NSV2),
   class__isSubclassOf_class(NMC,'-'),
   real__minus_real__is_real(N1,N2,N),
                                     % Predefined arithmetic of Prolog.
   state__isNextInstanceOf_stateVariable(N,NSV).
number__i_numericSv(N,NSV) :-
   nonvar(NSV),
   numericMc__mapsTo_numericSv(NMC,NSV),
   subtractionClass__divides_numericSv(NMC,NSV1),
   subtractionClass__dividesBy_numericSv(NMC,NSV2),
   stateVariable__isAssociatedWith_sort(NSV1,['SortOf','integerNumbers']),
   stateVariable__isAssociatedWith_sort(NSV2,['SortOf','integerNumbers']),
   state__isExplicitlyInstanceOf_stateVariable(N1,NSV1),
   state__isExplicitlyInstanceOf_stateVariable(N2,NSV2),
   class__isSubclassOf_class(NMC,'div'),
   int__div_int__is_integer(N1,N2,N),  % Predefined arithmetic of Prolog.
   state__isNextInstanceOf_stateVariable(N,NSV).
number__i_numericSv(N,NSV) :-
   nonvar(NSV),
   numericMc__mapsTo_numericSv(NMC,NSV),
   subtractionClass__divides_numericSv(NMC,NSV1),
   subtractionClass__dividesBy_numericSv(NMC,NSV2),
   stateVariable__isAssociatedWith_sort(NSV1,['SortOf','realNumbers']),
   stateVariable__isAssociatedWith_sort(NSV2,['SortOf','realNumbers']),
   state__isExplicitlyInstanceOf_stateVariable(N1,NSV1),
   state__isExplicitlyInstanceOf_stateVariable(N2,NSV2),
   class__isSubclassOf_class(NMC,'/'),
   real__dividedBy_real__is_real(N1,N2,N),
                                     % Predefined arithmetic of Prolog.
   state__isNextInstanceOf_stateVariable(N,NSV).


unitOfMeasure__isAssociatedWith_numericSv(UM,NSV) :-
   unitOfMeasure__isExplicitlyAssociatedWith_numericSv(UM,NSV).
unitOfMeasure__isAssociatedWith_numericSv(UM,NSV) :-
   UM = [UM1|[NMCsymbol|[UM2]]],
   nonvar(NSV),
   numericMc__mapsTo_numericSv(NMC,NSV),
   numericMc__mapsFrom_numericSv(NMC,NSV1),
   unitOfMeasure__isAssociatedWith_numericSv(UM1,NSV1),
   numericMc__mapsFrom_numericSv(NMC,NSV2),
   unitOfMeasure__isAssociatedWith_numericSv(UM2,NSV2),
   class__isSubclassOf_class(NMC,NMCsymbol).
            % Special case of division T.B.D.


numericMc__mapsFrom_numericSv(SC,NSV) :-
   subtractionClass__subtracts_numericSv(SC,NSV).
numericMc__mapsFrom_numericSv(SC,NSV) :-
   subtractionClass__subtractsBy_numericSv(SC,NSV).
numericMc__mapsFrom_numericSv(DC,DV) :-
   divisionClass__divides_numericSv(DC,DV).
numericMc__mapsFrom_numericSv(DC,DV) :-
   divisionClass__dividesBy_numericSv(DC,DV).

   
%:- consult('nmc.prp').
%:- consult('nmc.prc').
%:- consult('int.pro').
%:- consult('nat.pro').
