% QOSET.PRO: Abstractions about quasi ordered sets.
% (c) Author: Frans A. Meijs, 1998

set(S) :- qoSet(S).

concept__e_set(C1,C2) :-
   concept__e_qoSet(C1,C2).
   
concept__isExplicitlyAssociatedWith_concept(C1,C2) :-
   concept__isSubordinateTo_concept(C1,C2).
            % Is equivalent to  isImmediatelySubordinateTo

concept__isSubordinateTo_concept(C1,C2) :-
   concept__isExplicitlySubordinateTo_concept(C1,C2).
concept__isSubordinateTo_concept(C1,C2) :-
   concept__isExplicitlySubordinateTo_concept(C1,C3),
   concept__isSubordinateTo_concept(C3,C2).
   

set__isExplicitlyElementOf_set(S1,S2) :-
   qoSet__e_qoSet(S1,S2).


qoSet__e_qoSet(QS1,QS2) :-
   concept__e_qoSet(C,QS2),
   qoSet__isExplicitlySubordinateTo_concept(QS1,C).



