% SET.PRC

contradiction(['Contrad. class SET1: Concept', X,
   'seems to be a set but is not declared as such']) :-
   o_verifyingLogMsg('SET1'),
   concept__isExplicitlyElementOf_set(_, X),
   ~( set(X) ).
      % This is the Referential Integrity Constraint
      % from data base theory, part 1.


contradiction(['Contrad. class SET2: Concept', X,
   'seems to be a set but is not declared as such']) :-
   o_verifyingLogMsg('SET2'),
   set__isExplicitlyElementOf_set(X, _),
   ~( set(X) ).
      % This is the Referential Integrity Constraint
      % from data base theory, part 2.

      % Sets are required to be specified explicitly. The 
      % alternative, the introduction of the specification  
      %         "set(S) :- set__isExplicitlyElementOf_set(S,_)." 
      % may cause duplicate solutions, and 
      % hence may increase verification time considerably.



% The contradiction "concept__e_set(X, X)." is not queried for, as this 
% takes N**2 time. Checks of this type have to be performed at the most
% specific levels.



contradiction(['Contrad. class SET4: Set', S,
               'is also a class']) :-
   o_verifyingLogMsg('SET4'),
   set(S),
   class(S).                        % An individual set cannot be 
                                    % specified on these two levels
                                    % of abstraction at the same time.



