% SET.PRO: Abstractions about sets.
% Author: Frans Meijs, 1990


concept(C) :- set(C).


concept__isExplicitlyAssociatedWith_concept(C1,C2) :-
   set__intersects_set(C1,C2).
concept__isExplicitlyAssociatedWith_concept(C1,C2) :-
   concept__e_set(C1,C2).


concept__e_set(C,S) :-
   concept__isExplicitlyElementOf_set(C,S).
concept__e_set(C,S) :-
   nonvar(C),
   concept__isExplicitlyElementOf_set(C,S2),
   set__e_set(S2,S).
concept__e_set(C,S) :-
   var(C),nonvar(S),
   set__e_set(S2,S),
   concept__isExplicitlyElementOf_set(C,S2).


concept__isExplicitlyElementOf_set(C,S) :-
   eachInstanceOfClass__isExplicitlyElementOf_set(C,S).


set__e_set(S1,S2) :-
   set__isExplicitlyElementOf_set(S1,S2).
set__e_set(S1,S2) :-
   nonvar(S1),
   set__isExplicitlyElementOf_set(S1,S3),
   set__e_set(S3,S2).
set__e_set(S1,S2) :-
   var(S1), nonvar(S2),
   set__isExplicitlyElementOf_set(S3,S2),
   set__e_set(S1,S3).
                        % There are no cycles (See SET.PRC).                                    




%:- consult('set.prc').
