% SIMULATI.PRO: IPL model stimulating theory,
% for validating/simulation purposes.
% Author: Frans A. Meijs, oct 1999


simulationStep :-
   state__i_stateVariable(S,SV),
   o_chars(SV),
   o_chars(' = '),
   o_chars(S),
   o_eor.


state__i_stateVariable(S,SV) :-
   simulationTime(T1),
   stimulus(T2,SV,S),
   ~( msgv(SV) ),
   T1 >= T2,
   retract( stimulus(T2,SV,S) ).
         % Assumption: stimulus/3 facts are sorted with ascending T.
state__i_stateVariable(S,SV) :-
   sev__e_msgv(SV,MSGV),
   msg__i_msgv([S|_],MSGV).


msg__i_msgv(MSG,MSGV) :-
   simulationTime(T1),
   stimulus(T2,MSGV,MSG),
   msgv(MSGV),
   T1 >= T2,
   retract( stimulus(T2,MSGV,MSG) ).
         % Assumption: stimulus/3 facts are sorted with ascending T.
         

simulationTime(T) :-
   simulationTimeState(T2),
   retract( simulationTimeState(T2) ),
   simulationTimeStep(STT),
   T is T2 + STT,
   assert( simulationTimeState(T) ).


