% SU.PRC: The constraints

contradiction(
   ['Contrad. class SU1',BU,
    'is element of more than one structural unit',SU]) :-
   o_verifyingLogMsg('SU1'),
   behaviouralUnit__e_su(BU,SU),
   propositionSet__has_cardinalNumber(
      behaviouralUnit__e_su(BU,_),
      N),
   N > 1. 


contradiction(
   ['Contrad. class SU2',SU,
    'has more than one behavioural unit:',DSM,DSM2]) :-
   o_verifyingLogMsg('SU2'),
   behaviouralUnit__e_su(DSM,SU),
   behaviouralUnit__e_su(DSM2,SU),
   id__lt_id(DSM,DSM2).
  

contradiction(
   ['Contrad. class SU11',BU,
    'seems to be behavioural unit of',SU,
    'but is not declared as such']) :-
   o_verifyingLogMsg('SU11'),
   behaviouralUnit__e_su(BU,SU),
   ~( behaviouralUnit(BU) ).


contradiction(
   ['Contrad. class SU12',SU1,
    'seems to be structural unit of',SU2,
    'but is not declared as such']) :-
   o_verifyingLogMsg('SU12'),
   structuralUnit__e_su(SU1,SU2),
   ~( structuralUnit(SU1) ). 

contradiction(
   ['Contrad. class SU21: Structural unit',S1,
   'is explicitly private element of both',S2,
   'and',S3]) :-
   o_verifyingLogMsg('SU21'),
   structuralUnit__isExplicitlyPrivateElementOf_su(S1,S2),
   structuralUnit__isExplicitlyPrivateElementOf_su(S1,S3),
   id__lt_id(S2,S3).

   
contradiction(
   ['Contrad. class SU22: Structural unit',S1,
   'is both private element and shareable element of',S2]) :-
   o_verifyingLogMsg('SU22'),
   structuralUnit__isPrivateElementOf_su(S1,S2),
   structuralUnit__isShareableElementOf_su(S1,S2).

contradiction(
   ['Contrad. class SU31: Structural unit',S1,
   'and',S2,
   'are both roots of the aggregation tree']) :-
   o_verifyingLogMsg('SU31'),
   structuralUnit(S1),
   ~( structuralUnit__e_su(S1,_) ),
   structuralUnit(S2),
   id__lt_id(S1,S2),
   ~( structuralUnit__e_su(S2,_) ).

contradiction(
   ['Contrad. class SU41: State variable',SV,
   'is both private element and shareable element of',S2]) :-
   o_verifyingLogMsg('SU41'),
   stateVariable__isPrivateElementOf_su(SV,S2),
   stateVariable__isShareableElementOf_su(SV,S2).

contradiction(
   ['Contrad. class SU42: State variable',SV,
   'is both private element and input element of',S2]) :-
   o_verifyingLogMsg('SU42'),
   stateVariable__isPrivateElementOf_su(SV,S2),
   stateVariable__isInputElementOf_su(SV,S2).

contradiction(
   ['Contrad. class SU43: State variable',SV,
   'is both private element and output element of',S2]) :-
   o_verifyingLogMsg('SU43'),
   stateVariable__isPrivateElementOf_su(SV,S2),
   stateVariable__isOutputElementOf_su(SV,S2).

contradiction(
   ['Contrad. class SU51: Structural unit',SU1,
    'may be enabled simultaneously by',FSM1,
    'and',FSM2]) :-
   o_verifyingLogMsg('SU51'),
   ms__enables_su(MS1,SU1),
   ms__enables_su(MS2,SU1),
   id__lt_id(MS1,MS2),

   ms__isAssociatedWith_fsm(MS1,FSM1),
   behaviouralUnit__e_su(FSM1,SU2),
   ms__enables_su(MS3,SU2),

   ms__isAssociatedWith_fsm(MS2,FSM2),
   FSM1 \= FSM2,
   behaviouralUnit__e_su(FSM2,SU3),
   ms__enables_su(MS3,SU3).
               % Closure To Be Defined.


